<template>
  <el-form ref="loginFormRef" :model="loginForm" :rules="loginRules" size="large">
    <el-form-item prop="tenantNo" v-if="companytype">
      <el-input v-model="loginForm.tenantNo" placeholder="公司：admin / user">
        <template #prefix>
          <el-icon class="el-input__icon">
            <House />
          </el-icon>
        </template>
      </el-input>
    </el-form-item>
    <el-form-item prop="username">
      <el-input v-model="loginForm.username" placeholder="用户名：请输入用户名">
        <template #prefix>
          <el-icon class="el-input__icon">
            <user />
          </el-icon>
        </template>
      </el-input>
    </el-form-item>
    <el-form-item prop="password">
      <el-input
        v-model="loginForm.password"
        type="password"
        placeholder="密码：请输入密码"
        show-password
        autocomplete="new-password"
      >
        <template #prefix>
          <el-icon class="el-input__icon">
            <lock />
          </el-icon>
        </template>
      </el-input>
    </el-form-item>
  </el-form>
  <div class="login-btn">
    <el-button :icon="CircleClose" round size="large" @click="resetForm(loginFormRef)"> 重置 </el-button>
    <el-button :icon="UserFilled" round size="large" type="primary" :loading="loading" @click="login(loginFormRef)">
      登录
    </el-button>
  </div>
</template>

<script setup lang="ts">
import { ref, reactive, onMounted } from "vue";
import { useRouter, useRoute } from "vue-router";
import { HOME_URL } from "@/config";
import { getTimeState } from "@/utils";
import { Login } from "@/api/interface";
import { ElNotification } from "element-plus";
import { loginApi, userloginApi } from "@/api/modules/login";
// import { useUserStore } from "@/stores/modules/user";
import { useTabsStore } from "@/stores/modules/tabs";
import { useKeepAliveStore } from "@/stores/modules/keepAlive";
import { initDynamicRouter } from "@/routers/modules/dynamicRouter";
import { CircleClose, UserFilled } from "@element-plus/icons-vue";
import type { ElForm } from "element-plus";
// import { getuser } from "@/api/home/Multisite";
// import md5 from "md5";
const route = useRoute();

const router = useRouter();
// const userStore = useUserStore();
const tabsStore = useTabsStore();
const keepAliveStore = useKeepAliveStore();

type FormInstance = InstanceType<typeof ElForm>;
const loginFormRef = ref<FormInstance>();
const companytype = ref(true);
const loginRules = reactive({
  tenantNo: [{ required: true, message: "请输入公司", trigger: "blur" }],
  username: [{ required: true, message: "请输入用户名", trigger: "blur" }],
  password: [{ required: true, message: "请输入密码", trigger: "blur" }]
});

const loading = ref(false);
const loginForm = reactive<Login.ReqLoginForm>({
  username: "",
  password: "",
  tenantNo: "",
  rememberMe: true
});

// login
const login = (formEl: FormInstance | undefined) => {
  if (!formEl) return;
  formEl.validate(async valid => {
    if (!valid) return;
    loading.value = true;
    try {
      // 1.执行登录接口 md5(loginForm.password)
      if (companytype.value) {
        // 公司
        const { data } = await userloginApi({
          username: loginForm.username,
          password: loginForm.password,
          tenantNo: loginForm.tenantNo,
          rememberMe: true
        });
        console.log(data);

        // userStore.setToken(data.access_token);
      } else {
        // 用户
        const { data } = await loginApi({
          ...loginForm,
          rememberMe: false
        });
        console.log(data);

        // userStore.setToken(data.access_token);
      }
      if (companytype.value) {
      } else {
        // const { data } = await getuser();
        // console.log(data);
      }

      // 2.添加动态路由
      await initDynamicRouter();

      // 3.清空 tabs、keepAlive 数据
      tabsStore.setTabs([]);
      keepAliveStore.setKeepAliveName([]);
      router.push(HOME_URL);
      console.log(router.push(HOME_URL));
      // 4.跳转到首页

      ElNotification({
        title: getTimeState(),
        message: "欢迎登录 储能智慧云平台",
        type: "success",
        duration: 3000
      });
    } finally {
      loading.value = false;
    }
  });
};
// resetForm
const resetForm = (formEl: FormInstance | undefined) => {
  if (!formEl) return;
  formEl.resetFields();
};

onMounted(() => {
  // 总公司 undefined  // 公司 null
  if (route.query.company === null) {
    companytype.value = true;
  } else {
    companytype.value = false;
  }

  // 监听 enter 事件（调用登录）
  document.onkeydown = (e: KeyboardEvent) => {
    e = (window.event as KeyboardEvent) || e;
    if (e.code === "Enter" || e.code === "enter" || e.code === "NumpadEnter") {
      if (loading.value) return;
      login(loginFormRef.value);
    }
  };
});
</script>

<style scoped lang="scss">
@import "../index.scss";
</style>
